#include "polinom.h"
#include <stdio.h>

void unos(int a[], int n){
	//n je poznato, mi samo elemente treba da upisemo u niz a
	printf("Unesite elemente:\n");
	int i;
	for(i = 0; i < n; i++)
		scanf("%d", &a[i]);
}

void ispis(int a[], int n){
	printf("Elementi niza su:\n");
	int i;
	for(i = 0; i < n; i++)
		printf("%d ", a[i]);
	printf("\n");
}

int suma(int a[], int n){
	//cesto se pravi greska, samo int suma; bez = 0
	//ponekad radi na ispitu, a ne radi kada se automatski pregleda
	int suma = 0;
	int i;
	for(i = 0; i < n; i++)
		suma += a[i];
	return suma;
}

int skalarni(int a[], int b[], int n){
	//a1 * b1 + a2 * b2 + ... + an * bn
	int rez = 0;
	int i;
	for(i = 0; i < n; i++)
		rez += a[i] * b[i];
	return rez;
}

void ispis_polinoma(int a[], int n){
	//mi u nizu a imamo koeficijente polinoma na primer:
	//1 2 3 4 5
	//ispis:
	//1 + 2 * x + 3 * x^2 + 4 * x^3 + 5 * x^4
	
	//OBRATITI PAZNJU, NIZ IMA N ELEMENATA, ALI JE POLINOM STEPENA N-1
	//a po definiciji ove funkcije u zadatku, unosi se stepen polinoma, 
	//a ne broj elemenata
	
	//ako ucitamo niz a, sa n elemenata
	//funkciju zovemo: ispis_polinoma(a, n-1)
	
	//laksi slucaj
	//1 * x^0 + 2 * x^1 + 3 * x^2 + 4 * x^3 + 5 * x^4

	int i;
	int prvi_put = 1;
	for(i = 0; i <= n; i++){
		if(a[i] == 0)
			continue;
		//samo kada je i == 0, ne pisemo +
		
		if(prvi_put){
			prvi_put = 0;
		}
		else{
			printf(" + ");
		}
		
		if(i == 0)
			printf("%d", a[i]);
		else if(i == 1)
			printf("%d * x", a[i]);
		else
			printf("%d * x^%d", a[i], i);
	}
	printf("\n");
}

int suma_polinoma(int a[], int n, int b[], int m, int c[]){
	int stepen = n > m ? n : m;
	int i;
	for(i = 0; i < stepen; i++){
		c[i] = 0;
		if(i < n)
			c[i] += a[i];
		if(i < m)
			c[i] += b[i];
	}
	return stepen;
}